import { watch as o, onMounted as m, ref as r, unref as g, watchEffect as p, onUpdated as S, reactive as W, isReactive as R, toRaw as I, toRefs as P, toRef as T, getCurrentInstance as C, onUnmounted as E, nextTick as O, onActivated as Q, readonly as b } from "vue";
import { cloneDeep as h, isObject as j, deepMerge as F, getSlotsProps as f, isFunction as A } from "@gx-design-vue/pro-utils";
function B(e, t, i) {
  o(t, (n, a) => {
    i ? i(n, a) && e() : e();
  }), m(() => {
    e();
  });
}
const w = (typeof window > "u" ? !1 : /iPad|iPhone|iPod/.test(navigator.platform) || navigator.platform === "MacIntel" && navigator.maxTouchPoints > 1) && !window.MSStream;
function G() {
  return w;
}
const K = typeof window > "u" ? !1 : w || window.safari !== void 0;
function H() {
  return K;
}
const d = {
  xs: {
    maxWidth: 575,
    matchMedia: "(max-width: 575px)"
  },
  sm: {
    minWidth: 576,
    maxWidth: 767,
    matchMedia: "(min-width: 576px) and (max-width: 767px)"
  },
  md: {
    minWidth: 768,
    maxWidth: 991,
    matchMedia: "(min-width: 768px) and (max-width: 991px)"
  },
  lg: {
    minWidth: 992,
    maxWidth: 1199,
    matchMedia: "(min-width: 992px) and (max-width: 1199px)"
  },
  xl: {
    minWidth: 1200,
    maxWidth: 1599,
    matchMedia: "(min-width: 1200px) and (max-width: 1599px)"
  },
  xxl: {
    minWidth: 1600,
    matchMedia: "(min-width: 1600px)"
  }
}, k = () => {
  let e = "md";
  return typeof window > "u" || (e = Object.keys(d).find((i) => {
    const { matchMedia: n } = d[i];
    return !!window.matchMedia(n).matches;
  })), e;
}, J = () => {
  const e = r(k());
  return Object.keys(d).forEach((t) => {
    const { matchMedia: i } = d[t], n = window.matchMedia(i);
    n.matches && (e.value = t), n.onchange = (a) => {
      a.matches && (e.value = t);
    };
  }), e;
};
function L(e, t, i) {
  const n = r(e());
  return o(t, (a, u) => {
    i ? i(a, u) && (n.value = e()) : n.value = e();
  }), n;
}
function q(e) {
  const t = typeof e == "function" ? e() : e, i = r(t);
  function n(a) {
    i.value = a;
  }
  return [i, n];
}
function X(e, t) {
  const { defaultValue: i, value: n = r() } = t || {};
  let a = typeof e == "function" ? e() : e;
  n.value !== void 0 && (a = g(n)), i !== void 0 && (a = typeof i == "function" ? i() : i);
  const u = r(a), s = r(a), [l, x] = q([s.value]);
  p(() => {
    let c = n.value !== void 0 ? n.value : u.value;
    t != null && t.postState && (c = t.postState(c, u.value)), s.value = c;
  }), o(l, () => {
    var v;
    const c = l.value[0];
    u.value !== c && ((v = t == null ? void 0 : t.onChange) == null || v.call(t, u.value, c));
  }, { deep: !0 });
  function M(c) {
    u.value = c;
  }
  function y(c) {
    M(c), x([s.value]);
  }
  return o(n, () => {
    u.value = n.value;
  }), [s, y, u];
}
function Y(e, t) {
  const i = r(e[t]);
  return S(() => {
    const n = e[t];
    i.value !== n && (i.value = n);
  }), i;
}
function Z(e, t) {
  const i = typeof e == "function" ? e() : e, n = W({
    data: R(i) ? h(I(i)) : h(i)
  });
  function a(u) {
    u && j(u) && (n.data = F(n.data, u, t));
  }
  return [P(T(n, "data")), a];
}
function _(e, t, i, n) {
  const a = r(f(e, t, i, n));
  return o(e.map((u) => () => i[u]), () => {
    a.value = f(e, t, i, n);
  }, { deep: 1 }), o(() => t, () => {
    a.value = f(e, t, i, n);
  }, { deep: 1 }), a;
}
function D(e) {
  C() && E(e);
}
function $(e, t, i = !1) {
  if (!A(e))
    throw new Error("handle is not Function!");
  const { readyRef: n, stop: a, start: u } = N(t);
  return i ? e() : o(n, (s) => {
    s && e();
  }, { immediate: !1 }), { readyRef: n, stop: a, start: u };
}
function N(e) {
  const t = r(!1);
  let i;
  function n() {
    t.value = !1, i && window.clearTimeout(i);
  }
  function a() {
    n(), i = setTimeout(() => {
      t.value = !0;
    }, e);
  }
  return a(), D(n), { readyRef: t, stop: n, start: a };
}
function V(e) {
  let t;
  m(() => {
    e(!1), O(() => {
      t = !0;
    });
  }), Q(() => {
    t && e(!0);
  });
}
function ee() {
  const e = r(!1);
  return m(() => {
    e.value = !0;
  }), b(e);
}
export {
  V as onMountedOrActivated,
  D as tryOnUnmounted,
  B as useEffect,
  G as useIsIos,
  ee as useIsMounted,
  H as useIsSafari,
  J as useMediaQuery,
  L as useMemo,
  X as useMergedState,
  Y as usePickSlots,
  Z as useReactiveState,
  _ as useSlotsProps,
  q as useState,
  $ as useTimeout
};
